re PR ada/50294 (ICE in output_constructor_regular_field)
[gcc.git] / libgo / mksysinfo.sh
1 #!/bin/sh
2
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
6
7 # Create sysinfo.go.
8
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
13
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
18
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
21
22 set -e
23
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
27
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
163
164 /* Constants that may only be defined as expressions on some systems,
165 expressions too complex for -fdump-go-spec to handle. These are
166 handled specially below. */
167 enum {
168 #ifdef TIOCGWINSZ
169 TIOCGWINSZ_val = TIOCGWINSZ,
170 #endif
171 };
172 EOF
173
174 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
175
176 echo 'package syscall' > ${OUT}
177 echo 'import "unsafe"' >> ${OUT}
178 echo 'type _ unsafe.Pointer' >> ${OUT}
179
180 # Get all the consts and types, skipping ones which could not be
181 # represented in Go and ones which we need to rewrite. We also skip
182 # function declarations, as we don't need them here. All the symbols
183 # will all have a leading underscore.
184 grep -v '^// ' gen-sysinfo.go | \
185 grep -v '^func' | \
186 grep -v '^type _timeval ' | \
187 grep -v '^type _timespec_t ' | \
188 grep -v '^type _timespec ' | \
189 grep -v '^type _timestruc_t ' | \
190 grep -v '^type _epoll_' | \
191 grep -v 'in6_addr' | \
192 grep -v 'sockaddr_in6' | \
193 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
194 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
195 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
196 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
197 >> ${OUT}
198
199 # The errno constants. These get type Errno.
200 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
201 egrep '#define E[A-Z0-9_]+ ' | \
202 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
203
204 # The O_xxx flags.
205 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
206 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
207 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
208 echo "const O_ASYNC = 0" >> ${OUT}
209 fi
210 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
211 echo "const O_CLOEXEC = 0" >> ${OUT}
212 fi
213
214 # The signal numbers.
215 grep '^const _SIG[^_]' gen-sysinfo.go | \
216 grep -v '^const _SIGEV_' | \
217 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
218
219 # The syscall numbers. We force the names to upper case.
220 grep '^const _SYS_' gen-sysinfo.go | \
221 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
222 while read sys; do
223 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
224 echo "const $sup = _$sys" >> ${OUT}
225 done
226
227 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
228 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
229 echo "const SYS_GETDENTS = 0" >> ${OUT}
230 fi
231 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
232 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
233 fi
234
235 # Stat constants.
236 grep '^const _S_' gen-sysinfo.go | \
237 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
238
239 # Mmap constants.
240 grep '^const _PROT_' gen-sysinfo.go | \
241 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
242 grep '^const _MAP_' gen-sysinfo.go | \
243 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
244 grep '^const _MADV_' gen-sysinfo.go | \
245 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
246 grep '^const _MCL_' gen-sysinfo.go | \
247 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
248
249 # Process status constants.
250 grep '^const _W' gen-sysinfo.go |
251 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
252 # WSTOPPED was introduced in glibc 2.3.4.
253 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
254 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
255 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
256 else
257 echo 'const WSTOPPED = 2' >> ${OUT}
258 fi
259 fi
260 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
261 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
262 echo 'const WALL = ___WALL' >> ${OUT}
263 fi
264
265 # Networking constants.
266 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
267 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
268 grep '^const _SOMAXCONN' gen-sysinfo.go |
269 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
270 >> ${OUT}
271 grep '^const _SHUT_' gen-sysinfo.go |
272 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
273
274 # The net package requires some const definitions.
275 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
276 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
277 echo "const $m = 0" >> ${OUT}
278 fi
279 done
280
281 # pathconf constants.
282 grep '^const __PC' gen-sysinfo.go |
283 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
284
285 # The PATH_MAX constant.
286 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
287 echo 'const PathMax = _PATH_MAX' >> ${OUT}
288 fi
289
290 # epoll constants.
291 grep '^const _EPOLL' gen-sysinfo.go |
292 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
293 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
294 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
295 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
296 fi
297 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
298 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
299 fi
300
301 # Prctl constants.
302 grep '^const _PR_' gen-sysinfo.go |
303 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
304
305 # Ptrace constants.
306 grep '^const _PTRACE' gen-sysinfo.go |
307 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
308 # We need some ptrace options that are not defined in older versions
309 # of glibc.
310 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
311 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
312 fi
313 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
314 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
315 fi
316 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
317 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
318 fi
319 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
320 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
321 fi
322 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
323 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
324 fi
325 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
326 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
327 fi
328 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
329 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
330 fi
331 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
332 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
333 fi
334 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
335 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
336 fi
337 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
338 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
339 fi
340 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
341 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
342 fi
343 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
344 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
345 fi
346 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
347 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
348 fi
349 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
350 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
351 fi
352 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
353 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
354 fi
355 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
356 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
357 fi
358 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
359 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
360 fi
361
362 # The registers returned by PTRACE_GETREGS. This is probably
363 # GNU/Linux specific; it should do no harm if there is no
364 # _user_regs_struct.
365 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
366 if test "$regs" != ""; then
367 regs=`echo $regs | sed -e 's/type _user_regs_struct struct //' -e 's/[{}]//g'`
368 regs=`echo $regs | sed -e s'/^ *//'`
369 nregs=
370 while test -n "$regs"; do
371 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
372 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
373 # Capitalize the first character of the field.
374 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
375 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
376 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
377 field="$f$r"
378 nregs="$nregs $field;"
379 done
380 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
381 fi
382
383 # Some basic types.
384 echo 'type Size_t _size_t' >> ${OUT}
385 echo "type Ssize_t _ssize_t" >> ${OUT}
386 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
387 echo "type Offset_t _off64_t" >> ${OUT}
388 else
389 echo "type Offset_t _off_t" >> ${OUT}
390 fi
391 echo "type Mode_t _mode_t" >> ${OUT}
392 echo "type Pid_t _pid_t" >> ${OUT}
393 echo "type Uid_t _uid_t" >> ${OUT}
394 echo "type Gid_t _gid_t" >> ${OUT}
395 echo "type Socklen_t _socklen_t" >> ${OUT}
396
397 # The long type, needed because that is the type that ptrace returns.
398 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
399 if test "$sizeof_long" = "4"; then
400 echo "type _C_long int32" >> ${OUT}
401 elif test "$sizeof_long" = "8"; then
402 echo "type _C_long int64" >> ${OUT}
403 else
404 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
405 exit 1
406 fi
407
408 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
409 # double is commented by -fdump-go-spec.
410 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
411 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
412 fi
413 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
414 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
415 fi
416
417 # The time_t type.
418 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
419 echo 'type Time_t _time_t' >> ${OUT}
420 fi
421
422 # The time structures need special handling: we need to name the
423 # types, so that we can cast integers to the right types when
424 # assigning to the structures.
425 timeval=`grep '^type _timeval ' gen-sysinfo.go`
426 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
427 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
428 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
429 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
430 echo $timeval | \
431 sed -e 's/type _timeval /type Timeval /' \
432 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
433 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
434 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
435 if test "$timespec" = ""; then
436 # IRIX 6.5 has __timespec instead.
437 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
438 fi
439 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
440 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
441 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
442 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
443 echo $timespec | \
444 sed -e 's/^type ___timespec /type Timespec /' \
445 -e 's/^type _timespec /type Timespec /' \
446 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
447 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
448
449 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
450 if test "$timestruc" != ""; then
451 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
452 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
453 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
454 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
455 echo $timestruc | \
456 sed -e 's/^type _timestruc_t /type Timestruc /' \
457 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
458 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
459 fi
460
461 # The tms struct.
462 grep '^type _tms ' gen-sysinfo.go | \
463 sed -e 's/type _tms/type Tms/' \
464 -e 's/tms_utime/Utime/' \
465 -e 's/tms_stime/Stime/' \
466 -e 's/tms_cutime/Cutime/' \
467 -e 's/tms_cstime/Cstime/' \
468 >> ${OUT}
469
470 # The stat type.
471 # Prefer largefile variant if available.
472 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
473 if test "$stat" != ""; then
474 grep '^type _stat64 ' gen-sysinfo.go
475 else
476 grep '^type _stat ' gen-sysinfo.go
477 fi | sed -e 's/type _stat64/type Stat_t/' \
478 -e 's/type _stat/type Stat_t/' \
479 -e 's/st_dev/Dev/' \
480 -e 's/st_ino/Ino/g' \
481 -e 's/st_nlink/Nlink/' \
482 -e 's/st_mode/Mode/' \
483 -e 's/st_uid/Uid/' \
484 -e 's/st_gid/Gid/' \
485 -e 's/st_rdev/Rdev/' \
486 -e 's/st_size/Size/' \
487 -e 's/st_blksize/Blksize/' \
488 -e 's/st_blocks/Blocks/' \
489 -e 's/st_atim/Atim/' \
490 -e 's/st_mtim/Mtim/' \
491 -e 's/st_ctim/Ctim/' \
492 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
493 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
494 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
495 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
496 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
497 >> ${OUT}
498
499 # The directory searching types.
500 # Prefer largefile variant if available.
501 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
502 if test "$dirent" != ""; then
503 grep '^type _dirent64 ' gen-sysinfo.go
504 else
505 grep '^type _dirent ' gen-sysinfo.go
506 fi | sed -e 's/type _dirent64/type Dirent/' \
507 -e 's/type _dirent/type Dirent/' \
508 -e 's/d_name \[0+1\]/d_name [0+256]/' \
509 -e 's/d_name/Name/' \
510 -e 's/]int8/]byte/' \
511 -e 's/d_ino/Ino/' \
512 -e 's/d_off/Off/' \
513 -e 's/d_reclen/Reclen/' \
514 -e 's/d_type/Type/' \
515 >> ${OUT}
516 echo "type DIR _DIR" >> ${OUT}
517
518 # Values for d_type field in dirent.
519 grep '^const _DT_' gen-sysinfo.go |
520 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
521
522 # The rusage struct.
523 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
524 if test "$rusage" != ""; then
525 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
526 rusage=`echo $rusage | sed -e 's/^ *//'`
527 nrusage=
528 while test -n "$rusage"; do
529 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
530 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
531 # Drop the leading ru_, capitalize the next character.
532 field=`echo $field | sed -e 's/^ru_//'`
533 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
534 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
535 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
536 # Fix _timeval _timespec, and _timestruc_t.
537 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
538 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
539 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
540 field="$f$r"
541 nrusage="$nrusage $field;"
542 done
543 echo "type Rusage struct {$nrusage }" >> ${OUT}
544 else
545 echo "type Rusage struct {}" >> ${OUT}
546 fi
547
548 # The RUSAGE constants.
549 grep '^const _RUSAGE_' gen-sysinfo.go | \
550 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
551
552 # The utsname struct.
553 grep '^type _utsname ' gen-sysinfo.go | \
554 sed -e 's/_utsname/Utsname/' \
555 -e 's/sysname/Sysname/' \
556 -e 's/nodename/Nodename/' \
557 -e 's/release/Release/' \
558 -e 's/version/Version/' \
559 -e 's/machine/Machine/' \
560 -e 's/domainname/Domainname/' \
561 >> ${OUT}
562
563 # The iovec struct.
564 iovec=`grep '^type _iovec ' gen-sysinfo.go`
565 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
566 echo "type Iovec_len_t $iovec_len" >> ${OUT}
567 echo $iovec | \
568 sed -e 's/_iovec/Iovec/' \
569 -e 's/iov_base/Base/' \
570 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
571 >> ${OUT}
572
573 # The msghdr struct.
574 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
575 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
576 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
577 echo $msghdr | \
578 sed -e 's/_msghdr/Msghdr/' \
579 -e 's/msg_name/Name/' \
580 -e 's/msg_namelen/Namelen/' \
581 -e 's/msg_iov/Iov/' \
582 -e 's/msg_iovlen/Iovlen/' \
583 -e 's/_iovec/Iovec/' \
584 -e 's/msg_control/Control/' \
585 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
586 -e 's/msg_flags/Flags/' \
587 >> ${OUT}
588
589 # The MSG_ flags for Msghdr.
590 grep '^const _MSG_' gen-sysinfo.go | \
591 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
592
593 # The cmsghdr struct.
594 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
595 if test -n "$cmsghdr"; then
596 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
597 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
598 echo "$cmsghdr" | \
599 sed -e 's/_cmsghdr/Cmsghdr/' \
600 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
601 -e 's/cmsg_level/Level/' \
602 -e 's/cmsg_type/Type/' \
603 -e 's/\[\]/[0]/' \
604 >> ${OUT}
605 fi
606
607 # The SCM_ flags for Cmsghdr.
608 grep '^const _SCM_' gen-sysinfo.go | \
609 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
610
611 # The ucred struct.
612 grep '^type _ucred ' gen-sysinfo.go | \
613 sed -e 's/_ucred/Ucred/' \
614 -e 's/pid/Pid/' \
615 -e 's/uid/Uid/' \
616 -e 's/gid/Gid/' \
617 >> ${OUT}
618
619 # The ip_mreq struct.
620 grep '^type _ip_mreq ' gen-sysinfo.go | \
621 sed -e 's/_ip_mreq/IPMreq/' \
622 -e 's/imr_multiaddr/Multiaddr/' \
623 -e 's/imr_interface/Interface/' \
624 -e 's/_in_addr/[4]byte/g' \
625 >> ${OUT}
626
627 # We need IPMreq to compile the net package.
628 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
629 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
630 fi
631
632 # The ipv6_mreq struct.
633 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
634 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
635 -e 's/ipv6mr_multiaddr/Multiaddr/' \
636 -e 's/ipv6mr_interface/Interface/' \
637 -e 's/_in6_addr/[16]byte/' \
638 >> ${OUT}
639
640 # We need IPv6Mreq to compile the net package.
641 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
642 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
643 fi
644
645 # The ip_mreqn struct.
646 grep '^type _ip_mreqn ' gen-sysinfo.go | \
647 sed -e 's/_ip_mreqn/IPMreqn/' \
648 -e 's/imr_multiaddr/Multiaddr/' \
649 -e 's/imr_address/Address/' \
650 -e 's/imr_ifindex/Ifindex/' \
651 -e 's/_in_addr/[4]byte/g' \
652 >> ${OUT}
653
654 # We need IPMreq to compile the net package.
655 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
656 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
657 fi
658
659 # Try to guess the type to use for fd_set.
660 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
661 fds_bits_type="_C_long"
662 if test "$fd_set" != ""; then
663 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
664 fi
665 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
666
667 # The addrinfo struct.
668 grep '^type _addrinfo ' gen-sysinfo.go | \
669 sed -e 's/_addrinfo/Addrinfo/g' \
670 -e 's/ ai_/ Ai_/g' \
671 >> ${OUT}
672
673 # The addrinfo flags and errors.
674 grep '^const _AI_' gen-sysinfo.go | \
675 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
676 grep '^const _EAI_' gen-sysinfo.go | \
677 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
678
679 # The passwd struct.
680 grep '^type _passwd ' gen-sysinfo.go | \
681 sed -e 's/_passwd/Passwd/' \
682 -e 's/ pw_/ Pw_/g' \
683 >> ${OUT}
684
685 # The ioctl flags for the controlling TTY.
686 grep '^const _TIOC' gen-sysinfo.go | \
687 grep -v '_val =' | \
688 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
689 # We need TIOCGWINSZ.
690 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
691 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
692 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
693 fi
694 fi
695
696 # The ioctl flags for terminal control
697 grep '^const _TC[GS]ET' gen-sysinfo.go | \
698 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
699
700 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
701 # needs handling in syscalls.exec.go.
702 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
703 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
704 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
705 fi
706 fi
707
708 # The nlmsghdr struct.
709 grep '^type _nlmsghdr ' gen-sysinfo.go | \
710 sed -e 's/_nlmsghdr/NlMsghdr/' \
711 -e 's/nlmsg_len/Len/' \
712 -e 's/nlmsg_type/Type/' \
713 -e 's/nlmsg_flags/Flags/' \
714 -e 's/nlmsg_seq/Seq/' \
715 -e 's/nlmsg_pid/Pid/' \
716 >> ${OUT}
717
718 # The nlmsg flags and operators.
719 grep '^const _NLM' gen-sysinfo.go | \
720 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
721
722 # NLMSG_HDRLEN is defined as an expression using sizeof.
723 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
724 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
725 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
726 fi
727 fi
728
729 # The rtmsg struct.
730 grep '^type _rtmsg ' gen-sysinfo.go | \
731 sed -e 's/_rtmsg/RtMsg/' \
732 -e 's/rtm_family/Family/' \
733 -e 's/rtm_dst_len/Dst_len/' \
734 -e 's/rtm_src_len/Src_len/' \
735 -e 's/rtm_tos/Tos/' \
736 -e 's/rtm_table/Table/' \
737 -e 's/rtm_protocol/Protocol/' \
738 -e 's/rtm_scope/Scope/' \
739 -e 's/rtm_type/Type/' \
740 -e 's/rtm_flags/Flags/' \
741 >> ${OUT}
742
743 # The rtgenmsg struct.
744 grep '^type _rtgenmsg ' gen-sysinfo.go | \
745 sed -e 's/_rtgenmsg/RtGenmsg/' \
746 -e 's/rtgen_family/Family/' \
747 >> ${OUT}
748
749 # The routing message flags.
750 grep '^const _RT_' gen-sysinfo.go | \
751 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
752 grep '^const _RTA' gen-sysinfo.go | \
753 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
754 grep '^const _RTF' gen-sysinfo.go | \
755 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
756 grep '^const _RTCF' gen-sysinfo.go | \
757 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
758 grep '^const _RTM' gen-sysinfo.go | \
759 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
760 grep '^const _RTN' gen-sysinfo.go | \
761 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
762 grep '^const _RTPROT' gen-sysinfo.go | \
763 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
764
765 # The ifinfomsg struct.
766 grep '^type _ifinfomsg ' gen-sysinfo.go | \
767 sed -e 's/_ifinfomsg/IfInfomsg/' \
768 -e 's/ifi_family/Family/' \
769 -e 's/ifi_type/Type/' \
770 -e 's/ifi_index/Index/' \
771 -e 's/ifi_flags/Flags/' \
772 -e 's/ifi_change/Change/' \
773 >> ${OUT}
774
775 # The interface information types and flags.
776 grep '^const _IFA' gen-sysinfo.go | \
777 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
778 grep '^const _IFLA' gen-sysinfo.go | \
779 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
780 grep '^const _IFF' gen-sysinfo.go | \
781 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
782 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
783 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
784 grep '^const _SIOC' gen-sysinfo.go |
785 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
786
787 # The ifaddrmsg struct.
788 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
789 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
790 -e 's/ifa_family/Family/' \
791 -e 's/ifa_prefixlen/Prefixlen/' \
792 -e 's/ifa_flags/Flags/' \
793 -e 's/ifa_scope/Scope/' \
794 -e 's/ifa_index/Index/' \
795 >> ${OUT}
796
797 # The rtattr struct.
798 grep '^type _rtattr ' gen-sysinfo.go | \
799 sed -e 's/_rtattr/RtAttr/' \
800 -e 's/rta_len/Len/' \
801 -e 's/rta_type/Type/' \
802 >> ${OUT}
803
804 # The in_pktinfo struct.
805 grep '^type _in_pktinfo ' gen-sysinfo.go | \
806 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
807 -e 's/ipi_ifindex/Ifindex/' \
808 -e 's/ipi_spec_dst/Spec_dst/' \
809 -e 's/ipi_addr/Addr/' \
810 -e 's/_in_addr/[4]byte/g' \
811 >> ${OUT}
812
813 # The in6_pktinfo struct.
814 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
815 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
816 -e 's/ipi6_addr/Addr/' \
817 -e 's/ipi6_ifindex/Ifindex/' \
818 -e 's/_in6_addr/[16]byte/' \
819 >> ${OUT}
820
821 # The termios struct.
822 grep '^type _termios ' gen-sysinfo.go | \
823 sed -e 's/_termios/Termios/' \
824 -e 's/c_iflag/Iflag/' \
825 -e 's/c_oflag/Oflag/' \
826 -e 's/c_cflag/Cflag/' \
827 -e 's/c_lflag/Lflag/' \
828 -e 's/c_line/Line/' \
829 -e 's/c_cc/Cc/' \
830 -e 's/c_ispeed/Ispeed/' \
831 -e 's/c_ospeed/Ospeed/' \
832 >> ${OUT}
833
834 # The termios constants.
835 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
836 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
837 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
838 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
839 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
840 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
841 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
842 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
843 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
844 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
845 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
846 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
847
848 grep "^const _$n " gen-sysinfo.go | \
849 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
850 done
851
852 # The mount flags
853 grep '^const _MNT_' gen-sysinfo.go |
854 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
855 grep '^const _MS_' gen-sysinfo.go |
856 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
857
858 # The fallocate flags.
859 grep '^const _FALLOC_' gen-sysinfo.go |
860 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
861
862 # The statfs struct.
863 # Prefer largefile variant if available.
864 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
865 if test "$statfs" != ""; then
866 grep '^type _statfs64 ' gen-sysinfo.go
867 else
868 grep '^type _statfs ' gen-sysinfo.go
869 fi | sed -e 's/type _statfs64/type Statfs_t/' \
870 -e 's/type _statfs/type Statfs_t/' \
871 -e 's/f_type/Type/' \
872 -e 's/f_bsize/Bsize/' \
873 -e 's/f_blocks/Blocks/' \
874 -e 's/f_bfree/Bfree/' \
875 -e 's/f_bavail/Bavail/' \
876 -e 's/f_files/Files/' \
877 -e 's/f_ffree/Ffree/' \
878 -e 's/f_fsid/Fsid/' \
879 -e 's/f_namelen/Namelen/' \
880 -e 's/f_frsize/Frsize/' \
881 -e 's/f_flags/Flags/' \
882 -e 's/f_spare/Spare/' \
883 >> ${OUT}
884
885 # The timex struct.
886 timex=`grep '^type _timex ' gen-sysinfo.go || true`
887 if test "$timex" = ""; then
888 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
889 if test "$timex" != ""; then
890 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
891 fi
892 fi
893 if test "$timex" != ""; then
894 echo "$timex" | \
895 sed -e 's/_timex/Timex/' \
896 -e 's/modes/Modes/' \
897 -e 's/offset/Offset/' \
898 -e 's/freq/Freq/' \
899 -e 's/maxerror/Maxerror/' \
900 -e 's/esterror/Esterror/' \
901 -e 's/status/Status/' \
902 -e 's/constant/Constant/' \
903 -e 's/precision/Precision/' \
904 -e 's/tolerance/Tolerance/' \
905 -e 's/ time / Time /' \
906 -e 's/tick/Tick/' \
907 -e 's/ppsfreq/Ppsfreq/' \
908 -e 's/jitter/Jitter/' \
909 -e 's/shift/Shift/' \
910 -e 's/stabil/Stabil/' \
911 -e 's/jitcnt/Jitcnt/' \
912 -e 's/calcnt/Calcnt/' \
913 -e 's/errcnt/Errcnt/' \
914 -e 's/stbcnt/Stbcnt/' \
915 -e 's/tai/Tai/' \
916 -e 's/_timeval/Timeval/' \
917 >> ${OUT}
918 fi
919
920 # The rlimit struct.
921 grep '^type _rlimit ' gen-sysinfo.go | \
922 sed -e 's/_rlimit/Rlimit/' \
923 -e 's/rlim_cur/Cur/' \
924 -e 's/rlim_max/Max/' \
925 >> ${OUT}
926
927 # The RLIMIT constants.
928 grep '^const _RLIMIT_' gen-sysinfo.go |
929 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
930 grep '^const _RLIM_' gen-sysinfo.go |
931 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
932
933 # The sysinfo struct.
934 grep '^type _sysinfo ' gen-sysinfo.go | \
935 sed -e 's/_sysinfo/Sysinfo_t/' \
936 -e 's/uptime/Uptime/' \
937 -e 's/loads/Loads/' \
938 -e 's/totalram/Totalram/' \
939 -e 's/freeram/Freeram/' \
940 -e 's/sharedram/Sharedram/' \
941 -e 's/bufferram/Bufferram/' \
942 -e 's/totalswap/Totalswap/' \
943 -e 's/freeswap/Freeswap/' \
944 -e 's/procs/Procs/' \
945 -e 's/totalhigh/Totalhigh/' \
946 -e 's/freehigh/Freehigh/' \
947 -e 's/mem_unit/Unit/' \
948 >> ${OUT}
949
950 # The ustat struct.
951 grep '^type _ustat ' gen-sysinfo.go | \
952 sed -e 's/_ustat/Ustat_t/' \
953 -e 's/f_tfree/Tfree/' \
954 -e 's/f_tinode/Tinoe/' \
955 -e 's/f_fname/Fname/' \
956 -e 's/f_fpack/Fpack/' \
957 >> ${OUT}
958 # Force it to be defined, as on some older GNU/Linux systems the
959 # header file fails when using with <linux/filter.h>.
960 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
961 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
962 fi
963
964 # The utimbuf struct.
965 grep '^type _utimbuf ' gen-sysinfo.go | \
966 sed -e 's/_utimbuf/Utimbuf/' \
967 -e 's/actime/Actime/' \
968 -e 's/modtime/Modtime/' \
969 >> ${OUT}
970
971 # The LOCK flags for flock.
972 grep '^const _LOCK_' gen-sysinfo.go |
973 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
974
975 # The GNU/Linux LINUX_REBOOT flags.
976 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
977 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
978
979 # The GNU/Linux sock_filter struct.
980 grep '^type _sock_filter ' gen-sysinfo.go | \
981 sed -e 's/_sock_filter/SockFilter/' \
982 -e 's/code/Code/' \
983 -e 's/jt/Jt/' \
984 -e 's/jf/Jf/' \
985 -e 's/k /K /' \
986 >> ${OUT}
987
988 # The GNU/Linux sock_fprog struct.
989 grep '^type _sock_fprog ' gen-sysinfo.go | \
990 sed -e 's/_sock_fprog/SockFprog/' \
991 -e 's/len/Len/' \
992 -e 's/filter/Filter/' \
993 -e 's/_sock_filter/SockFilter/' \
994 >> ${OUT}
995
996 # The GNU/Linux filter flags.
997 grep '^const _BPF_' gen-sysinfo.go | \
998 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
999
1000 # The GNU/Linux nlattr struct.
1001 grep '^type _nlattr ' gen-sysinfo.go | \
1002 sed -e 's/_nlattr/NlAttr/' \
1003 -e 's/nla_len/Len/' \
1004 -e 's/nla_type/Type/' \
1005 >> ${OUT}
1006
1007 # The GNU/Linux nlmsgerr struct.
1008 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1009 sed -e 's/_nlmsgerr/NlMsgerr/' \
1010 -e 's/error/Error/' \
1011 -e 's/msg/Msg/' \
1012 -e 's/_nlmsghdr/NlMsghdr/' \
1013 >> ${OUT}
1014
1015 # The GNU/Linux rtnexthop struct.
1016 grep '^type _rtnexthop ' gen-sysinfo.go | \
1017 sed -e 's/_rtnexthop/RtNexthop/' \
1018 -e 's/rtnh_len/Len/' \
1019 -e 's/rtnh_flags/Flags/' \
1020 -e 's/rtnh_hops/Hops/' \
1021 -e 's/rtnh_ifindex/Ifindex/' \
1022 >> ${OUT}
1023
1024 # The GNU/Linux netlink flags.
1025 grep '^const _NETLINK_' gen-sysinfo.go | \
1026 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1027 grep '^const _NLA_' gen-sysinfo.go | \
1028 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1029
1030 # The GNU/Linux packet socket flags.
1031 grep '^const _PACKET_' gen-sysinfo.go | \
1032 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1033
1034 # The GNU/Linux inotify_event struct.
1035 grep '^type _inotify_event ' gen-sysinfo.go | \
1036 sed -e 's/_inotify_event/InotifyEvent/' \
1037 -e 's/wd/Wd/' \
1038 -e 's/mask/Mask/' \
1039 -e 's/cookie/Cookie/' \
1040 -e 's/len/Len/' \
1041 -e 's/name/Name/' \
1042 -e 's/\[\]/[0]/' \
1043 -e 's/\[0\]byte/[0]int8/' \
1044 >> ${OUT}
1045
1046 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1047 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1048 sed -e 's/_in6_addr/[16]byte/' \
1049 >> ${OUT}
1050
1051 # Struct sizes.
1052 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1053 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1054 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1055 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1056 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1057 sock_filter SockFilter sock_fprog SockFprog ucred Ucred
1058 while test $# != 0; do
1059 nc=$1
1060 ngo=$2
1061 shift
1062 shift
1063 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1064 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1065 fi
1066 done
1067
1068 # In order to compile the net package, we need some sizes to exist
1069 # even if the types do not.
1070 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1071 echo 'const SizeofIPMreq = 8' >> ${OUT}
1072 fi
1073 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1074 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1075 fi
1076 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1077 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1078 fi
1079
1080 exit $?